diff -uNr xawtv-3.85.orig/libng/contrib-plugins/bilinear.c xawtv-3.85/libng/contrib-plugins/bilinear.c
--- xawtv-3.85.orig/libng/contrib-plugins/bilinear.c	Sun Aug 31 21:22:56 2003
+++ xawtv-3.85/libng/contrib-plugins/bilinear.c	Tue Sep  2 22:27:52 2003
@@ -32,14 +32,17 @@
 static void inline
 deinterlace (struct ng_video_buf *frame)
 {
-  unsigned int x, y;
-
+  int x, y;
+  unsigned char *src, *psrc, *nsrc;
+  src = frame->data + frame->fmt.bytesperline;
   for (y = 1; y < frame->fmt.height - 1; y += 2)
+  {
+    psrc = src - frame->fmt.bytesperline;
+    nsrc = src + frame->fmt.bytesperline;
     for (x = 0; x < frame->fmt.bytesperline + 1; x++)
-      (frame->data[y * (frame->fmt.bytesperline) + x]) =
-	((frame->data[((y - 1) * (frame->fmt.bytesperline)) + x]) +
-	 (frame->data[((y + 1) * (frame->fmt.bytesperline)) + x])) >> 1;
-
+      *(src + x) = (*(psrc + x) + *(nsrc + x)) >> 1;
+    src += frame->fmt.bytesperline << 1;
+  }
 }
 
 
diff -uNr xawtv-3.85.orig/libng/contrib-plugins/linear-blend.c xawtv-3.85/libng/contrib-plugins/linear-blend.c
--- xawtv-3.85.orig/libng/contrib-plugins/linear-blend.c	Sun Aug 31 21:22:56 2003
+++ xawtv-3.85/libng/contrib-plugins/linear-blend.c	Tue Sep  2 22:27:52 2003
@@ -21,6 +21,7 @@
  * Linear blend deinterlacing algorithm adapted from mplayer's libpostproc
  */
 
+
 #include "config.h"
 
 #include <stdio.h>
@@ -29,8 +30,11 @@
 
 #include "grab-ng.h"
 
+
 #define PAVGB(a,b)  "pavgb " #a ", " #b " \n\t"
 
+#define MMX
+
 #ifdef MMX
 #define emms()                  __asm__ __volatile__ ("emms")
 #else
@@ -104,16 +108,14 @@
 static void inline
 deinterlace (struct ng_video_buf *frame)
 {
-  unsigned int x, y, bytes = frame->fmt.bytesperline;
+  int x, y, bytes = frame->fmt.bytesperline;
   unsigned char *src;
-
+  src = frame->data + bytes;
   for (y = 1; y < frame->fmt.height - 8; y+=8)
   {
         for (x = 0; x < bytes; x+=8)
-        {
-            src = frame->data + x + y * bytes;
-            linearBlend(src, bytes);
-        } 
+            linearBlend(src + x, bytes);
+	src += bytes << 3;
   }
 
   emms();
